import { World, BlockLocation } from "mojang-minecraft";

export function getDimension(player) {
  if (player.dimension) {
    return player.dimension;
  }
  
  let location = new BlockLocation(Math.floor(player.location.x), Math.floor(player.location.y), Math.floor(player.location.z));
  
  let dimensions = [
    World.getDimension("overworld"),
    World.getDimension("nether"),
    World.getDimension("the end")
  ];
    
  let entitiesAtPlayerLocation = [
    dimensions[0].getEntitiesAtBlockLocation(location),
    dimensions[1].getEntitiesAtBlockLocation(location),
    dimensions[2].getEntitiesAtBlockLocation(location)
  ];
      
  let dimension;
      
  entitiesAtPlayerLocation.forEach(entities => {
    entities.forEach(entity => {
      if (entity.name == player.name && entity.id == "minecraft:player") {
        dimension = dimensions[entitiesAtPlayerLocation.indexOf(entities)];
      }
    });
  });
  
  return dimension;
}


export function growBlocks(player, growth) {
  let location_ = [player.location.x,player.location.y,player.location.z].map(Math.floor());
  
  let location = new BlockLocation(...location_);
  
  let blocks = [];
  let offsets = [
    [ 0, 0, 0 ], [ -1, 0, 0 ], [ 0, 0, -1 ],
    [ 1, 0, 0 ], [ 0, 0, 1 ], [ -1, 0, -1 ],
    [ 1, 0, -1 ], [ 0, 0, -2 ], [ -1, 0, -2 ],
    [ 1, 0, -2]
  ];
  
  offsets.forEach(offset => {
    blocks.push(getDimension(player).getBlock(location.offset(...offset)));
  });
  
  blocks.forEach(block => {
    if (block.permutation.getProperty("growth")) {
      let perm = block.permutation;
      
      (perm.getProperty("growth").value + growth) > 7 ? perm.getProperty("growth").value = 7 : perm.getProperty("growth").value = (perm.getProperty("growth").value + growth);
      
      block.setPermutation(perm);
      
    }
  });
  
}

