// Created By: Felipe G a m e r.

import { World, Commands, MinecraftEffectTypes } from "mojang-minecraft";
import { getItems, findItem } from "./lib/inventory.js";
import { getDimension, growBlocks } from "./lib/utils.js";

World.events.tick.subscribe(() => {
  let players = World.getPlayers();

  for (let i in players) {
    let p = players[i];
    let items = getItems(p.getComponent("inventory").container);
    let speed = findItem(items, {id:"wb:speed_ring", amount:1});
    let jump = findItem(items, {id:"wb:jump_ring", amount:1});
    let strength = findItem(items, {id:"wb:strength_ring", amount:1});
    let health = findItem(items, {id:"wb:health_ring", amount:1});
    let haste = findItem(items, {id:"wb:haste_ring", amount:1});
    let fire = findItem(items, {id:"wb:fire_ring", amount:1});
    let magnetic_ring = findItem(items, {id:"wb:magnet_ring",amount:1});

    let effects = [];
    let magnet = false;
    

    speed > -1 ? effects.push(MinecraftEffectTypes.speed) : "";
    jump > -1 ? effects.push(MinecraftEffectTypes.jumpBoost) : "";
    strength > -1 ? effects.push(MinecraftEffectTypes.strength) : "";
    health > -1 ? effects.push(MinecraftEffectTypes.regeneration) : "";
    haste > -1 ? effects.push(MinecraftEffectTypes.haste) : "";
    fire > -1 ? effects.push(MinecraftEffectTypes.fireResistance) : "";
    magnetic_ring > -1 ? magnet = true : false;
    
    effects.forEach(eff => {
      p.addEffect(eff, 40, 0);
    });
    
    if (magnet) {
      Commands.run(`execute @a[name="${p.name}"] ~~~ tp @e[type=item,r=3] @s`, getDimension(p));
    }
    
    
    
  }
  
});
